//Макет прошивки для CEC CD3100/CD2100, PARASOUND CBD2000
//Dxx573k// RYAZAN 2020
// no current version
// 06.07.2020 добавлены развороты при чтении таблицы содержания. пока не оттестированы.
// 24.07.2020 добавлена перемотка вперед и назад, переход на следующий трек, обслуживание команды SEARCH, контроль окончания диска.
// 25.07.2020 изменены тайминги подачи команды PLAY. сделана пауза в 4 миллисекунды. добавлен статус PLAY_MID
// 31.07.2020 исправлена ошибка инициализации сервы. небыло паузы.

#include <SPI.h>// inslude the SPI library:
#include <LiquidCrystal.h>
LiquidCrystal lcd(0,19,18,17,16,15); // (RS, E, DB4, DB5, DB6, DB7)

const int RW_Pin = 9;    // set pin 8 as the R/W line for write command to YM7121C
const int WQ_Pin = 8;    // set pin 9 as the WQ line for read status from YM7121C
const int LASER_Pin = 2; // set pin 2 as the LASER_ON
const int PUIN_Pin = 6;  // set pin 6 as a PickUp IN sensor
const int AnalogPin=0;   // порт АЦП для кнопок управления.
const int MOSIPin=11;    // SPI PIN Configuration
const int MISOPin=12;    // SPI PIN Configuration
const int SCKPin=13;     // SPI PIN Configuration
const int CLOSE_Pin=4;   // set pin 4 as the CLOSE output line.

unsigned long Time_start=0;//millis() long это для отсчета времени.Time_start=millis();// время интервала, милисекунды
unsigned long Time_end=0;
unsigned long Time_Q_old=0; // время между Q байтами
unsigned long Time_Q_new=0; // время между Q байтами

byte key_press=0;   // текущее значение analog in. Считывается с порта за 110мкс.
byte key_hold=0;    // хранит данные, какая кнопка сейчас нажата
byte key_denoize=0; // счетчик дребезга (до 64)
byte key_press2=0;  // предыдущее значение analog_in. обслуживает подавление дребезга
byte key_lock=0;    // защелка для кнопок и команд
int counter1=0;     // Универсальный счетчик
int counter2=0;     // Универсальный счетчик

byte status_player=255; //сдесь хранится статус проигрывателя 11111 - 1-мотор_стоп - 1-нет_фокуса - 1-новый Q код
                        // первые три бита используются под перемотку - search
                        // 4 b 5 ,биты используются для индикации Frame Error 4 и 8 фреймов.
byte COM_ADR=0;         // второй байт данных. сдесь кодируется валидность Q-CODE.
byte TOC_A0=0;          //байт - номер первого трека
byte TOC_A1=0;          //байт - номер последнего трека.
byte TOC_READ_OK=0;     //байт - признак прочитанного TOC
byte TOC_table[104][3]; // это таблица диска. в [101]резерв, в строке [0] байты А2 - LEADOUT
                        // в столбще [3]- ничего нет резерв.
                        // номер строки - номер трека
                        // в столбце [0] - MIN
                        // в столбце [1] - SEC
                        // в столбце [2] - FRAME
                        // содержимое массивов Q_byte
                        //[1] TNO
                        //[2] X
                        //[3] MIN
                        //[4] SEC
                        //[5] FRAME 0-74
                        //[6] PAUSE
                        //[7] AMIN
                        //[8] ASEC
                        //[9] AFRAME
byte Q_byte_new[10];    // последний прочитанный массив Q в [1] находится TNO, в [9] находится последний байт AFRAME
byte Q_byte_old[10];    // предыдущий прочитанный массив Q  в [1] находится TNO, в[9] находится последний байт AFRAME
byte TOC_MIN=0;         // сдесь нет кода BCD!!!
byte TOC_SEC=0;         // это для мотания назад. сдесь находится -9 секунд относительно окончания TOC.
byte TOC_FRAME=160;     // сдесь нет кода BCD!!!
byte TOC_POINT=0;       // Это для преобразования кода BCD в номер трека.
byte CURRENT_TRACK=0;   // Это для перемотки вперед и назад.
String Command_mode;    // отработчик комманд, скриптов и ошибок.
String Global_mode;     // сдесь или PLAY или STOP.
String Current_mode;    // текущий статус, чем занимается сидюк.
String Err_message; 

byte Print_status=0;      //сдесь все, что печатаем на экране.
byte Print_COM_ADR=0;     //сдесь все, что печатаем на экране.
String Print_command;     //сдесь все, что печатаем на экране.
String Print_current;     //сдесь все, что печатаем на экране.
byte Print_TNO=12;        //сдесь все, что печатаем на экране.
byte Print_Track=12;      //сдесь все, что печатаем на экране.
byte Print_MIN=0;         //сдесь все, что печатаем на экране.
byte Print_SEC=0;         //сдесь все, что печатаем на экране.
byte Print_PAUSE=12;      //сдесь все, что печатаем на экране.
char Print_PUIN='L';      //сдесь все, что печатаем на экране.
char PUIN_='-';           //специально, чтобы сразу напечаталась правда, а не ждал одного изменения.

// инициализация переменных и сервы.
void setup() {
Global_mode=String("STOP");
Command_mode=String("INIT_ALL");
Current_mode=String("INIT_SERVO");
Err_message=String("SERVO_ERROR");
Print_command=String("NONE     ");
Print_current=String("NONE     ");

   lcd.begin(20, 4);                  // Задаем размерность экрана

  // set the PIN MODE IN/OUT:
  pinMode(RW_Pin, OUTPUT);
  pinMode(WQ_Pin, INPUT);
  pinMode(LASER_Pin, OUTPUT);
  pinMode(PUIN_Pin, INPUT);
  digitalWrite(PUIN_Pin, HIGH);  //подтягиваем PUIN до 5В.
  digitalWrite(LASER_Pin, HIGH); //выключаем лазер
  digitalWrite(RW_Pin, LOW);     //Подтягиваем RW к 0В
  digitalWrite(WQ_Pin, LOW);     //Подтягиваем WQ к 0В
  
  // initialize SPI:
  SPI.begin();
  SPI.beginTransaction ( SPISettings (600000, MSBFIRST, SPI_MODE3));

  // CLEARING TOC TABLE
  for (counter1=0; counter1<(104); counter1++) { //обнуляем таблицу
                TOC_table[counter1][0]=0;
                TOC_table[counter1][1]=0;
                TOC_table[counter1][2]=0;};
  // CLEAR Q_BYTE TABLE
  for (counter1=0; counter1<(10); counter1++) { //обнуляем таблицу
                Q_byte_new[counter1]=0;
                Q_byte_old[counter1]=0;};           
 
  Command_Init();  //INIT YM7121C
}

//основной цикл.
void loop() {
 keyboard();    //читам кнопки
 print_prog();  //печатаем изменения на экране
 manual();      //переключаем режимы.
 
//ALLTIME ASK WQ STATUS.
if (digitalRead(WQ_Pin)==HIGH) Command_Read(status_player);   // это читает статус сервы по получению сиглана WQ
if (Current_mode==String ("STOP"))                            // пытаемся остановиться.
        {Command_Write(112);                                  //DISK BREAK
        //сюда надо паузу прописать и сделать больше статусов STOP
        Command_Write(0);
        // CLEAR Q_BYTE TABLE
        for (counter1=0; counter1<(10); counter1++) {         //обнуляем таблицу
                Q_byte_new[counter1]=0;
                Q_byte_old[counter1]=0;};
        Current_mode=String("PARKING");}
//PARKING PICKUP    
if (digitalRead(PUIN_Pin)==HIGH) PUIN_='H'; // концевой выключатель пикапа. пикап не запаркова
if (digitalRead(PUIN_Pin)==LOW) {PUIN_='L';} //digitalWrite(CLOSE_Pin, LOW);} // концевой выключатель пикапа. пикап уперт в стеку. Запаркован. Костыль защиты
if ((Current_mode==String("INIT_SERVO"))&&(status_player!=0)) Current_mode=String ("INIT_OK"); // попытка инициализации сервы
if (Current_mode==String("INIT_OK")&&((millis()-Time_Q_new)>3)) {Current_mode=String ("PARKING");}
if (Current_mode==String ("PARKING")&&(PUIN_=='H'))                   //едем к центру
        {Command_Write(48); digitalWrite(CLOSE_Pin, HIGH);};          //едем к центру
if (Current_mode==String ("PARKING")&&(PUIN_=='L'))                   //тормозим у центра
        {Command_Write(0); Current_mode=String("FIND_ZERO"); digitalWrite(CLOSE_Pin, LOW);};
if (Current_mode==String ("FIND_ZERO")&&(PUIN_=='L')) Command_Write(32); //отползаем от центра
if (Current_mode==String ("FIND_ZERO")&&(PUIN_=='H')) {Command_Write(0); Current_mode=String ("PICKUP_RDY");}; //успешно отползли. Останавливаемся.

//START FOCUS AND DISK
if (Current_mode==String ("PICKUP_RDY")&&(TOC_READ_OK==0)) {            // включаем фокус. эта часть нужна, если не прочитана TOC (новый диск)
        delay(3);   //сдесь гораздо проще поставить delay, чем мудрить с Millis()
         Command_Write(64);                             //FOCUS ON
        digitalWrite(LASER_Pin, LOW);                   //LASER ON
        Time_start=millis();                            // контроль времени включения.
        Current_mode=String ("FOCUS_WAIT");}

if ((Current_mode==String ("PICKUP_RDY"))&&(Global_mode==("PLAY"))) {// включаем фокус это для команды плей.
        delay(3);                        //сдесь гораздо проще поставить delay, чем мудрить с Millis()
        Command_Write(64);              //FOCUS ON
        digitalWrite(LASER_Pin, LOW);   //LASER ON
        Time_start=millis();
        Current_mode=String ("FOCUS_WAIT");}
        
//STOP AFTER TOC READING
if ((Current_mode==String ("PICKUP_RDY")&&(TOC_READ_OK!=0)&&(Global_mode==String ("STOP")))) Current_mode=String ("STOP"); //особый режим для STOP        

if (Current_mode==String ("FOCUS_WAIT")&&(millis()-Time_start>5000)) {      //Нет Диска.
        Command_Write(0);
        digitalWrite(LASER_Pin, HIGH);      // отключаем лазер.
        Current_mode=String ("NO_DISK");};  // нет диска.

if (Current_mode==String ("FOCUS_WAIT")&&((status_player&2)==0)) Current_mode=String ("FOCUS_OK");

if ((Current_mode==String ("FOCUS_OK"))&&((millis()-Time_Q_new)>3)) { //включаем PLAY_MUTE и ждем Q-CODE задержка необходима.
        Command_Write(144); //PLAY MUTE
        Time_start=millis();
        Current_mode=String ("PLMUTE_WT");};
        
if (Current_mode==String ("PLMUTE_WT")&&(millis()-Time_start>25000)) {
        Current_mode=String ("DISK_ERROR"); //не смог за 25 секунд прочитать Q-байт.
        Command_Write(0);
        digitalWrite(LASER_Pin, HIGH);};        //выключение лазера


        
if (Current_mode==String ("PLMUTE_WT")&&((status_player&2)==1)) {
        Current_mode=String ("DISK_ERROR");     // потеря фокуса.
        Command_Write(0);
        digitalWrite(LASER_Pin, HIGH);};          //выключение лазера
        
// строку ниже надо продублировать, если мы успешно прочитали таблицу.
 if ((Current_mode==String ("PLMUTE_WT"))&&((status_player&1)==1)) { //мы приняли ПЕРВЫЙ Q-CODE! диск начал проигрываться.
         Current_mode=String ("PLAY_MUTE");
        Time_start=millis();} // засекаем время чтения TOC.


//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
// тут не хватает поиска начала 1 трека, если мы очутились не в зоне LEAD-IN
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1

//выносим чтение таблицы в отдельную подпрограмму.
if (TOC_READ_OK==0) TOC_read_proc();

        
// отключается на время отладки чтения TOC//
if (((Current_mode==String ("PLAY_MUTE"))||(Current_mode==String ("PLAY_BACK")))&&(TOC_READ_OK==0)&&((millis()-Time_start)>10000)) {
        Current_mode= String("TOC_ERROR");
         Command_Write(0);
        digitalWrite(LASER_Pin, HIGH);} //выключение лазера
// отключается на время отладки чтения TOC//

// вот мы и прочитали TOC.
if ((Current_mode==String ("PLAY_BACK"))&&(TOC_READ_OK==1)&&((millis()-Time_Q_new)>3)) {Current_mode=String("PLAY_MUTE");  Command_Write(144); }//PLAY MUTE Разворот если TOC нормально прочиталась.
// теперь мы точно читаем вперед

if((TOC_READ_OK!=0)&&(Global_mode==String ("STOP"))&&((millis()-Time_Q_new)>3)) // сдесь мы прочитали TOC, но пользователь не нажал PLAY, значит надо остановиться и подождать.
        {Current_mode=String ("STOP"); Command_Write(0); digitalWrite(LASER_Pin, HIGH);}
        
// это перемотка вперед на 1 трек.
if ((Current_mode==String("PLAY_MUTE"))&&(Q_byte_new[1]==0)&&(TOC_READ_OK==1)&&((millis()-Time_Q_new)>3)) {// пытаемся использовать команду TRACK KICK если мы все еще на треке 0
        Current_mode=String("SKIP_TOC");
        //delay(3);
        Command_Write(192);}
if ((Current_mode==String ("SKIP_TOC"))&&(Q_byte_new[1]!=0)&&(TOC_READ_OK==1)&&((millis()-Time_Q_new)>3)) { // пытаемся на быстрой перемотке найти 1 трек.
        Current_mode=String("PLAY_MID"); Command_Write(144); Time_start=millis();}

if ((Current_mode==String ("PLAY_MID"))&&((millis()-Time_start)>50)) Current_mode=String ("PLAY_READY");  //попытка победить проскальзывания.

if ((Current_mode==String ("PLAY_READY"))&&((millis()-Time_Q_new)>3)) {         //попытка победить проскальзывания.
        Current_mode=String("PLAY_LOUD");
        Command_Write(128);}


// тут закончил 22.12.2020......................................////////////////////////////////////////

       
if (Current_mode==String ("PLAY_LOUD")) CURRENT_TRACK=(Q_byte_new[1]&15)+(10*(Q_byte_new[1]>>4)); //это для считывания текущего трека. не забываем про BCD коды.

//кусок кода по произвольному переходу между треками.
//SEARCH CONTROL
if ((Current_mode==String("SEARCH"))&&(millis()-Time_Q_new>31)) Command_Read(status_player); // чтение статуса не дожидаясь WQ, как написано в даташите. при поиске трека. в оригинальной прошивке тут 32мс


if ((Current_mode==String("SEARCH"))&&(millis()-Time_Q_new>100)) {
          Command_Search(224,TOC_table[CURRENT_TRACK][0],TOC_table[CURRENT_TRACK][1], TOC_table[CURRENT_TRACK][2]);} //тестовый антизависатор перемотки
//if ((Current_mode==String("PLAY_LOUD"))&&(millis()-Time_Q_new>100)) { //тестовый антизависатор проигрывателя
//          Command_Write (0); //STOP
//          delay(3000); //PAUSE
//          for(counter1=0;counter1<10; counter1++)
//          {Command_Write(0);
//          {Command_Write(112); //Disk Brake
//          delay(13);}
//          Command_Write (0); //STOP
//          delay(100); //PAUSE
//          Current_mode=String ("PICKUP_RDY");}
 //         Command_Write(64);          //FOCUS ON  
 //         delay(80);
 //         Command_Write(128);
//          Current_mode=String ("PICKUP_RDY"); //PLAY MUTE
//          }
          
if ((Current_mode==String("SEARCH"))&&((status_player&96)==0)&&((millis()-Time_Q_new)>3)) {
             // delay(3); // технологическая пауза
              Command_Write(144); //PLAY_MUTE
              Current_mode=String ("PLAY_MID");
              Command_mode=String ("NOTHING"); Time_start=millis(); }
//SEARCH CONTROL END

//LEADOUT CONTROL
if ((Q_byte_new[1]==170)&&((millis()-Time_Q_new)>3)) { Current_mode=String("PARKING"); Global_mode=String ("STOP"); delay(3); Command_Write(0); digitalWrite(LASER_Pin, HIGH); Q_byte_new[1]=0;} // проверка на окончание диска по TNO и запись в Q_byte_new, чтобы не попасть в бесконечный цикл.
if (((Q_byte_new[7]>=TOC_table[0][0])&&(Q_byte_new[8]>=TOC_table[0][1])&&(Q_byte_new[9]>=TOC_table[0][2]))&&(Q_byte_new[1]!=0)&&((millis()-Time_Q_new)>3)) // проверка, что текущий ATIME больше или равен A2 TOC и играет трек отличный от 0 
          { Current_mode=String("PARKING"); delay(3); Command_Write(0); Global_mode=String ("STOP"); digitalWrite(LASER_Pin, HIGH);  Q_byte_new[1]=0; Q_byte_new[7]=0;} //проверка на окончание диска по TOC_TABLE 
          // паркуемся, включаем стоп, гасим лазер, ставим номер трека 0, чтобы не было зацикленности.
//LEADOUT CONTROL END

//PAUSE CONTROL
if ((Current_mode==String("PLAY_PAUSE"))&&((millis()-Time_Q_new)>3))   //включаем паузу
      {Command_Search(224,Q_byte_new[7],Q_byte_new[8], Q_byte_new[9]); // отдаем команду на текущий Q-CODE
      Current_mode=String("PAUSE_ON");  // включаем режим паузы
      Command_mode=String ("NOTHING");} // это для того, чтобы пауза тут-же не выключилась.
if ((Current_mode==String("PAUSE_ON"))&&(millis()-Time_Q_new>31))  Command_Read(status_player);  // в процессе паузы чтение статуса не дожидаясь WQ, как написано в даташите. при поиске трека.   
if ((Current_mode==String("PLAY_AGAIN"))&&((millis()-Time_Q_new)>3)) // выключаем паузу.    
      {Command_Write(144); //PLAY_MUTE
       Current_mode=String ("PLAY_MID"); // через промежуточный PLAY MUTE.
       Command_mode=String ("NOTHING"); Time_start=millis(); }
//PAUSE CONTROL END
}
//конец основного цикла.

//процедура чтения таблицы TOC сюда приходим только если TOC_READ_OK==0;
void TOC_read_proc() {
//это внешний цикл чтения заглавия. Если условие на строке ниже выполняется, значит мы еще не прочитали TOC и получили очередной Q-CODE.
if (((Current_mode==String ("PLAY_MUTE"))||(Current_mode==String ("PLAY_BACK")))&&((status_player&7)==1)) { //Есть новый Q-байт, не важно вперед или назад читает. И главное таблица не прочитана.
        //Ниже чтение одной строки со всеми прибабахами. // ((COM_ADR&15)==1)&& не убрано из условия. Оно есть при чтении данных с сервы
        if (((COM_ADR&15)==1)&&(Q_byte_new[1]==0)&&(Q_byte_new[6]==0)) {         //Проверяем, что Q-CODE валидный, играет трек 0 и это не пауза.
              if (Q_byte_new[2]==160) TOC_A0=(Q_byte_new[7]&15)+(10*(Q_byte_new[7]>>4)); //Номер первого трека в коде BCD
              if (Q_byte_new[2]==161) TOC_A1=(Q_byte_new[7]&15)+(10*(Q_byte_new[7]>>4)); //Номер последнего трека в коде BCD
              if (Q_byte_new[2]==162) {TOC_table[0][0]=Q_byte_new[7]; TOC_table[0][1]=Q_byte_new[8]; TOC_table[0][2]=Q_byte_new[9];}; // начало LEAD_OUT 
              TOC_POINT=(Q_byte_new[2]&15)+(10*(Q_byte_new[2]>>4));    //переводим BCD код в нормальные числа.
              if (TOC_POINT<104) {TOC_table[TOC_POINT][0]=Q_byte_new[7]; TOC_table[TOC_POINT][1]=Q_byte_new[8]; TOC_table[TOC_POINT][2]=Q_byte_new[9];}; //читаем строку оглавления.            
              }; // прочитали 1 строку. Причем любую.
             
        //Проверяем целостность таблицы оглавления. Вдруг мы уже все прочитали.
       if (((TOC_A1!=0)&&(TOC_A0!=0))&&((TOC_table[0][0]+TOC_table[0][1]+TOC_table[0][2])>0)) { //проверяем целостность таблицы А0 А1 А2 знак >= нужен для того, чтобы правильно читать диски с 1 треком.
                 TOC_READ_OK=1; // это можно убирать на время отладки.!!
                for (counter1=TOC_A0; counter1<(TOC_A1+1); counter1++) { //проверяем целостность таблицы TOC
                           if ((TOC_table[counter1][0]+TOC_table[counter1][1]+TOC_table[counter1][2])==0) {TOC_READ_OK=0; counter2=counter1;}}//проверяем целостность таблицы каждой лини       
                }; //конец проверки целостности таблицы оглавления.

        //Мы же все еще не прочитали оглавление. но вылетели за пределы TOC.
        //Тут, по хорошему надо отслеживать обе границы, чтобы делать ревинд назад, и не упереть головку в стенку.
        //Условие ниже - Q-CODE валидный, ( трек не 0, или пауза ), таблица еще не прочитана.

        // разворачиваем чтение назад.
       if (((COM_ADR&15)==1)&&((Q_byte_new[1]!=0)||(Q_byte_new[6]==255))&&(TOC_READ_OK==0)&&((millis()-Time_Q_new)>3)) { //Мы дошли до паузы 1 трека. надо менять статус. и ехать назад. то что это "PLAY_MUTE" учтено в условии выше.
                              //заодно уточним, что Q_byte_old[6]=0 -то есть раньше паузы небыло.
          //delay(3);
          Command_Write(220); //команда чтения назад.
          Current_mode=String ("PLAY_BACK"); //начинаем играть назад c двухкратной скоростью без звука. //это как перемотка. 
          // надо засечь 7 секунд. Последний TIME находится в Q_byte_old!!!!!!
             TOC_MIN=Q_byte_old[3];
             TOC_SEC=Q_byte_old[4];       // загружаем TOC_TIME из Q_byte_old.
          TOC_FRAME=8;          // используем не по назначению. Убавляем пока он не будет равен 0.
          // вычитаем из TOC_TIME 8 раз.
          }  

          // разворачиваем чтение вперед. Cчитаем, сколько Q_CODE _SEC мы приняли и убавляем счетчик.
         if((Current_mode==String ("PLAY_BACK"))) { //проверка на -9 секунд TOC.
              if ((TOC_SEC!=Q_byte_new[4])) { // это проверка того, что мы отъехали назад больше чем на секунду.
                TOC_MIN=Q_byte_new[3];    // обновили TOC_TIME
                TOC_SEC=Q_byte_new[4];
                TOC_FRAME=TOC_FRAME-1;};    // уменьшили на 1 секунду чтения.
                }; 
              
          // разворачиваем чтение вперед.
         if ((TOC_FRAME==0)&&(Current_mode==String ("PLAY_BACK"))&&((millis()-Time_Q_new)>3)) {Current_mode=String("PLAY_MUTE"); Command_Write(144); }//PLAY MUTE Разворот в прямо при чтении TOC.

        //Если мы успешно прочитали оглавление, то выходим из этого цикла, и ставим TOC_READ_OK==1 чтобы никогда сюда не попасть.
        if (TOC_READ_OK==1) {
            TOC_FRAME=160;} // это лучше в инициализацию перенести. где лоток открывается /закрывается.        
       }; //Конец обработки нового Q_байта
  
}
//Конец процедуры чтения таблицы TOC


// Подпрограмма ручного управления.
// Связывает нажатые кнопки и реальные действия.
// инженерный режим.
void manual() {
   
         // Command_Write(64);  //Focus start
         // Command_Write(0);   //Stop
         // Command_Write(144); //Play Mute
         // Command_Write(128); //Play Loud
         // Command_Write(32);  //FEED Forward
         // Command_Write(48);  //FEED Return
         // Command_Write(96);  //Disk Start
         // Command_Write(112); //Disk Brake
         // Command_Write(220); // FB*2 ZERO VOLUME
         // Command_Write(1);   //+1 TRACK KICK
         // Command_Write(17);  //-1 TRACK KICK
         // Command_Write(160); //FF*2 0,25 Volume
         // Command_Write(176); //FB*2 0,25 Volume
         // Command_Write(192); // FFF 0,25 Volume
         // Command_Write(208); // FFB 0,25 Volume
         // Command_Write(8);   //INITIAL SET
         // Command_Search(224,minute, second, frame);
key_lock=1; // защелка для корректной работы переключателей.

      if (Command_mode==String ("PLAY_DISK_")) {if (Global_mode==String("STOP")) {Global_mode=String("PLAY"); Current_mode=String ("PARKING"); key_lock=0;}// глобальная переключалка    
                                                if ((Current_mode==String("PLAY_LOUD"))&&(key_lock==1)) {Current_mode=String("PLAY_PAUSE"); key_lock=0;} // переключатель на паузу.
                                                if ((Current_mode==String("PAUSE_ON"))&&(key_lock==1)) {Current_mode=String("PLAY_AGAIN"); key_lock=0;} // переключатель с паузы на плей.
                                                }; // меняем глобальный статус на PLAY.
      if (Command_mode==String ("STOP_DISK_")) {delay(3); Command_Write(0); digitalWrite(LASER_Pin, HIGH);
                                                Current_mode=String ("STOP");
                                                Global_mode=String("STOP");
                                                }; //выключаем лазер, меняем статус на "стоп", меняем глобальный статус на "стоп".

// отрабатываем кнопкку перехода на следующий трек диска. пока только на 1 трек.
// CURRENT_TRACK обновляется только во время PLAY_LOUD! так что все норм.                                                
      if ((Command_mode==String ("NEXT_TRACK"))&&((Current_mode==String("PLAY_LOUD"))||(Current_mode==String("SEARCH")))) {
                        Command_mode=String ("NOTHING"); // вторая часть защелки.
                        CURRENT_TRACK++;
                        if (CURRENT_TRACK>TOC_A1) CURRENT_TRACK=TOC_A0; // пони бегает по кругу.
                        Current_mode=String ("SEARCH");
                        delay(3);
                        Command_Search(224,TOC_table[CURRENT_TRACK][0],TOC_table[CURRENT_TRACK][1], TOC_table[CURRENT_TRACK][2]);}; //следующий трек.

      if ((Command_mode==String ("FORWARD_RW"))&&(Current_mode==String("PLAY_LOUD"))) {delay (3); Command_Write(192); Current_mode=String("FORWARD_RW");} // тут перемотка вперед
      if ((Command_mode==String ("NO_KEY_PR_"))&&(Current_mode==String("FORWARD_RW"))) {delay(3); Command_Write(128); Current_mode=String("PLAY_LOUD");} // отключаем перемотку вперед
      
      if ((Command_mode==String ("BACKWARD_R"))&&(Current_mode==String("PLAY_LOUD"))) {delay(3); Command_Write(208); Current_mode=String("BACKWARD_R");} // тут перемотка назад
      if ((Command_mode==String ("NO_KEY_PR_"))&&(Current_mode==String("BACKWARD_R"))) {delay(3); Command_Write(128); Current_mode=String("PLAY_LOUD");} // отключаем перемотку назад 

// CURRENT_TRACK обновляется только во время PLAY_LOUD! так что все норм.       
      if ((Command_mode==String ("PREVIOUS_T"))&&((Current_mode==String("PLAY_LOUD"))||(Current_mode==String("SEARCH")))) {
                        Command_mode=String ("NOTHING"); // вторая часть защелки.
                        if ((CURRENT_TRACK==TOC_A0)&&(Q_byte_new[3]==0)&&(Q_byte_new[4]<5)) CURRENT_TRACK=TOC_A1+1; // пони бегает по кругу.
                        if ((CURRENT_TRACK>TOC_A0)&&(Q_byte_new[3]==0)&&(Q_byte_new[4]<5)) CURRENT_TRACK--; // проверяем что мы в самом начале трека, и только тогда убавляем.
                        
                        Current_mode=String ("SEARCH");
                        delay(3);
                        Command_Search(224,TOC_table[CURRENT_TRACK][0],TOC_table[CURRENT_TRACK][1], TOC_table[CURRENT_TRACK][2]);}; //предыдущий трек.
     
      if (Command_mode==String ("OPEN_CLOSE")) {Command_Write(112); digitalWrite(LASER_Pin, HIGH);Current_mode=String ("OPENCL_OK");}; //выключаем лазер, меняем статус.             

}
//конец программы ручного управления и выбора режима


// Подпрограмма отработчик клавиатуры.
// Возвращает строку команды Command_mode.
// key_hold - это текущая нажатая кнопка 0 - ни одна кнопка не нажата.
// key_press - это то, что прочитано прямо сейчас.
// key_press2 - это то, что было прочитано в прошлый раз.

void keyboard(){
key_press=analogRead(AnalogPin)>>7; // Читаем содержимое АЦП, отбрасываем 7 разрядов из 10

if (key_press!=key_hold) { // сдесь накапливаем нажатие кнопки. Отпускание тоже накапливаем.
      key_denoize++;
      if (key_press!=key_press2) key_denoize=0; // Это дребезг!
      key_press2=key_press;};
     
if (key_denoize==64) {// сдесь включаем кнопку
          key_hold=key_press;
          key_denoize=0;};

 //включаем режим Command_mode
 if (key_hold==0) Command_mode=String ("NO_KEY_PR_");
 if ((key_hold==1)&&(Command_mode!=String("NOTHING"))) Command_mode=String ("PLAY_DISK_"); //Это защелка на PLAY
 if (key_hold==2) Command_mode=String ("STOP_DISK_");
 if ((key_hold==3)&&(Command_mode!=String("NOTHING"))) Command_mode=String ("NEXT_TRACK"); //Это защелка на NEXT TRACK
 if (key_hold==4) Command_mode=String ("FORWARD_RW");
 if (key_hold==5) Command_mode=String ("BACKWARD_R");
 if ((key_hold==6)&&(Command_mode!=String("NOTHING"))) Command_mode=String ("PREVIOUS_T"); //Это защелка на PREVIOUS TRACK
 if (key_hold==7) Command_mode=String ("OPEN_CLOSE");

}
//Конец подпрограммы Keyboard;

// Подпрограмма печати служебных данных.
void print_prog() {  //Процедура печати на экране. Печатаются только изменения.
  
  if (Print_command!=Command_mode) {// печатаем последнюю команду.
      lcd.setCursor(0, 0);
      lcd.print(Command_mode);
      Print_command=Command_mode;};
      
  if (Print_current!=Current_mode) {// печатаем режим работы
      lcd.setCursor(0, 1);
      lcd.print(Current_mode);
      Print_current=Current_mode;};

  if (Print_status!=status_player) {//печатаем байт статуса
      lcd.setCursor(0, 2);
      for (counter1=0; counter1<8; counter1++) 
        {lcd.print((status_player>>(7-counter1))&1);};
      Print_status=status_player;};         // Выводим текст  в битах 
  
        lcd.setCursor(0, 3);
        lcd.print(millis()-Time_Q_new); 
        lcd.print("   ");
// это то что выше, для отработки антиразгона.

        lcd.setCursor(8, 3);
        lcd.print(TOC_READ_OK);
        
  if (Print_TNO!=CURRENT_TRACK) { //Печатаем номер трека, правильней CURRENT_TRACK а не Q_byte_new[1]
      lcd.setCursor(11, 0);
      if (CURRENT_TRACK<128) lcd.print(CURRENT_TRACK);
     Print_TNO=CURRENT_TRACK;};

//  if (Print_TNO!=Q_byte_new[1]) { //Печатаем номер трека сдесь тоже BCD
//      lcd.setCursor(11, 0);
//      if (Q_byte_new[1]<128){
//      lcd.print(Q_byte_new[1]>>4);
//      lcd.print(Q_byte_new[1]&15);};
//     Print_TNO=Q_byte_new[1];};

  if (Print_Track!=Q_byte_new[2]) { // Печатаем X . При проигрывании бесполезная вещь. только с TOC сдесь указатель на номер трека.
      lcd.setCursor(14, 0);
      if (Q_byte_new[1]<128){
      lcd.print(Q_byte_new[2]>>4);
      lcd.print(Q_byte_new[2]&15);};
      Print_Track=Q_byte_new[2];};
      
  if (Print_MIN!=Q_byte_new[3]) { // Печатаем минуты
      lcd.setCursor(11, 1);
      lcd.print(Q_byte_new[3]>>4);
      lcd.print(Q_byte_new[3]&15);
      Print_MIN=Q_byte_new[3];};
      
   if (Print_SEC!=Q_byte_new[4]) { // Печатаем секунды
      lcd.setCursor(14, 1);
      lcd.print(Q_byte_new[4]>>4);
      lcd.print(Q_byte_new[4]&15);
      Print_SEC=Q_byte_new[4];};

  if (Print_PAUSE!=Q_byte_new[6]) { // Печатаем паузу
    lcd.setCursor(11, 2);
    //lcd.print(Q_byte_new[6]);
    if (Q_byte_new[6]==0) lcd.print("DATA ");
    if (Q_byte_new[6]==255) lcd.print("PAUSE");
    Print_PAUSE=Q_byte_new[6];};
    
  if (Print_PUIN!=PUIN_) {            // Печатаем концевик парковки
     lcd.setCursor(11, 3);
     lcd.print(PUIN_);
     Print_PUIN=PUIN_;};
  
  if (TOC_READ_OK==1) {                //считали всю TOC
     lcd. setCursor(15, 3);
     lcd.print(TOC_table[0][0]>>4);       //печатаем данные А1-А0, А2 как в больших сидюках.
      lcd.print(TOC_table[0][0]&15);      //печатаем данные А1-А0, А2 как в больших сидюках.

  lcd. setCursor(18, 3);
     lcd.print(TOC_table[0][1]>>4);       //печатаем данные А1-А0, А2 как в больших сидюках.
      lcd.print(TOC_table[0][1]&15);    //печатаем данные А1-А0, А2 как в больших сидюках.
  lcd. setCursor(18, 2);
     lcd.print(1+TOC_A1-TOC_A0);}      //печатаем данные А1-А0         
}

//Конец подпрограммы print_prog;

void Command_Init(){//INIT YM7121C
  ACC_RW_Write();
  delayMicroseconds(80);//TIMING COPIED FROM ORIGINAL FIRMWARE.
  ACC_RW_Write();
  delayMicroseconds(80);
  Command_Write(8);} //INITIAL SET. MUST Resieve a status after What.
  
 //Подпрограмма выдачи однобайтовых комманд на серву.
void Command_Write(byte address) {
  
  digitalWrite(RW_Pin, HIGH);     // take the RW pin high to write command:
  delayMicroseconds(2);           // минимальная пауза 1мкс 
  SPI.transfer(address);          //  send in the address and value via SPI:
  delayMicroseconds(2);           // минимальная пауза 1мкс
  digitalWrite(RW_Pin, LOW);      // take the RW pin low to end command:
  }
// Конец подпрограммы записи команд в серву.

// Подпрограмма выдачи команды SEARCH на серву.
void Command_Search(byte address, byte S_min, byte S_sec, byte s_frame) {

digitalWrite(RW_Pin, HIGH);       // take the RW pin high to write command:
delayMicroseconds(2);             // минимальная пауза 1мкс
SPI.transfer(address);            //  send in the address and value via SPI:
delayMicroseconds(2);             // минимальная пауза 1мкс
SPI.transfer(S_min);
delayMicroseconds(2);             // минимальная пауза 1мкс
SPI.transfer(S_sec);
delayMicroseconds(2);             // минимальная пауза 1мкс
SPI.transfer(s_frame);
delayMicroseconds(2);             // минимальная пауза 1мкс
digitalWrite(RW_Pin, LOW);        // take the RW pin low to end command:
  }
// Конец подпрограммы выдачи команды SEARCH
 
//Подпрограмма читает Q-CODE с сервы.
//Читает в глобальные переменные.
byte Command_Read(byte status_read) {
 status_player=SPI.transfer(0); //Отдельно читаем статус сидюка
 delayMicroseconds(4);          //По даташиту тут должно быть не менее 0,5мкс. Я сделал 4, в оригинале стояло 50мкс.
 COM_ADR=SPI.transfer(0);       //Отдельно читаем второй байт COM_ADR
 delayMicroseconds(4);
 Time_Q_old=Time_Q_new;         // отслеживание регулярности Q
 Time_Q_new=millis();           // отслеживание регулярности Q
 if ((status_player&1>0)&&((COM_ADR&15)==1)) {          //проверяем наличие нового Q-сообщения и его валидность.
      for (counter2=1; counter2<10; counter2++) {
            Q_byte_old[counter2]=Q_byte_new[counter2];  //запоминаем старое Q-сообщение
            Q_byte_new[counter2]=SPI.transfer(0);       // читаем новое Q-сообщения
            delayMicroseconds(4); };                    // сдесь должно быть не менее 0,5мкс. оригинале стояло 10мкс.
      }; 
   delayMicroseconds(10); // по новому прочнетию даташита, тут должно быть не менее 12мкс.             

 ACC_RW_Write(); //Подтверждаем окончание чтения.
}
// Конец подпрограммы чтения Q-CODE.

void ACC_RW_Write()   //Подтверждение получения статуса. отдельная процедура нужна для инициализации и финализации чтения статусов и Q-кодов.
{
  digitalWrite(RW_Pin, HIGH); // дергаем RW вверх
  delayMicroseconds(1);       // на время 1 байта передачи данных по SPI
  digitalWrite(RW_Pin, LOW);  // дергаем RW вниз.
}
